import { ActorRefFrom, AnyActorRef } from 'xstate';
import { BuiltImage, MultiscaleSpatialImage } from '@itk-viewer/io/MultiscaleSpatialImage.js';
import { Ranges } from '@itk-viewer/io/types.js';
type Point = readonly [number, number];
type Context = {
    image: MultiscaleSpatialImage;
    dataRanges: Ranges;
    colorRanges: Ranges;
    normalizedColorRanges: Ranges;
    colorMaps: string[];
    opacityPoints: Point[][];
    normalizedOpacityPoints: Point[][];
};
export declare const image: import("xstate").StateMachine<Context, {
    type: "getWorker";
    receiver: AnyActorRef;
} | {
    type: "builtImage";
    builtImage: BuiltImage;
} | {
    type: "colorRange";
    range: readonly [number, number];
    component: number;
} | {
    type: "normalizedColorRange";
    range: readonly [number, number];
    component: number;
} | {
    type: "opacityPoints";
    points: Point[];
    component: number;
} | {
    type: "normalizedOpacityPoints";
    points: Point[];
    component: number;
} | {
    type: "colorMap";
    colorMap: string;
    component: number;
}, {}, never, import("xstate").Values<{
    updateColorRanges: {
        type: "updateColorRanges";
        params: import("xstate").NonReducibleUnknown;
    };
    updateNormalizedColorRanges: {
        type: "updateNormalizedColorRanges";
        params: import("xstate").NonReducibleUnknown;
    };
    updateOpacityPoints: {
        type: "updateOpacityPoints";
        params: import("xstate").NonReducibleUnknown;
    };
    updateNormalizedOpacityPoints: {
        type: "updateNormalizedOpacityPoints";
        params: import("xstate").NonReducibleUnknown;
    };
    ensureComponentDefaults: {
        type: "ensureComponentDefaults";
        params: import("xstate").NonReducibleUnknown;
    };
}>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
    readonly id: "image";
    readonly initial: "active";
    readonly context: ({ input: image }: {
        spawn: {
            <TSrc extends never>(logic: TSrc, ...[options]: never): never;
            <TLogic extends import("xstate").AnyActorLogic>(src: TLogic, options?: {
                id?: never;
                systemId?: string;
                input?: import("xstate").InputFrom<TLogic> | undefined;
                syncSnapshot?: boolean;
            } | undefined): ActorRefFrom<TLogic>;
        };
        input: MultiscaleSpatialImage;
        self: import("xstate").ActorRef<import("xstate").MachineSnapshot<Context, {
            type: "getWorker";
            receiver: AnyActorRef;
        } | {
            type: "builtImage";
            builtImage: BuiltImage;
        } | {
            type: "colorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "normalizedColorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "opacityPoints";
            points: Point[];
            component: number;
        } | {
            type: "normalizedOpacityPoints";
            points: Point[];
            component: number;
        } | {
            type: "colorMap";
            colorMap: string;
            component: number;
        }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
            type: "getWorker";
            receiver: AnyActorRef;
        } | {
            type: "builtImage";
            builtImage: BuiltImage;
        } | {
            type: "colorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "normalizedColorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "opacityPoints";
            points: Point[];
            component: number;
        } | {
            type: "normalizedOpacityPoints";
            points: Point[];
            component: number;
        } | {
            type: "colorMap";
            colorMap: string;
            component: number;
        }, import("xstate").AnyEventObject>;
    }) => {
        image: MultiscaleSpatialImage;
        dataRanges: never[];
        colorRanges: never[];
        normalizedColorRanges: never[];
        colorMaps: never[];
        opacityPoints: never[];
        normalizedOpacityPoints: never[];
    };
    readonly states: {
        readonly active: {
            readonly on: {
                readonly builtImage: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<Context, {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                };
                readonly colorRange: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                };
                readonly normalizedColorRange: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, "updateColorRanges"];
                };
                readonly opacityPoints: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                };
                readonly normalizedOpacityPoints: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                };
                readonly colorMap: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, {
                        type: "getWorker";
                        receiver: AnyActorRef;
                    } | {
                        type: "builtImage";
                        builtImage: BuiltImage;
                    } | {
                        type: "colorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "normalizedColorRange";
                        range: readonly [number, number];
                        component: number;
                    } | {
                        type: "opacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "normalizedOpacityPoints";
                        points: Point[];
                        component: number;
                    } | {
                        type: "colorMap";
                        colorMap: string;
                        component: number;
                    }, undefined, never, never, never, never, never>];
                };
            };
        };
    };
}>;
export type Image = ActorRefFrom<typeof image>;
export type ImageSnapshot = ReturnType<Image['getSnapshot']>;
export {};
//# sourceMappingURL=image.d.ts.map