import { ActorRefFrom, AnyActorLogic, AnyActorRef } from 'xstate';
import { MultiscaleSpatialImage, BuiltImage } from '@itk-viewer/io/MultiscaleSpatialImage.js';
import { Image } from './image.js';
import { CreateChild } from './children.js';
import { Camera } from './camera.js';
import { ViewportActor } from './viewport.js';
type Context = {
    spawned: AnyActorRef[];
    scale: number;
    image?: MultiscaleSpatialImage;
    imageActor?: Image;
    viewport?: ViewportActor;
    camera?: Camera;
    autoCameraReset: boolean;
};
export declare const view3d: import("xstate").StateMachine<Context, CreateChild | {
    type: "setImage";
    image: MultiscaleSpatialImage;
} | {
    type: "setScale";
    scale: number;
} | {
    type: "createRenderer";
    logic: AnyActorLogic;
} | {
    type: "setViewport";
    viewport: ViewportActor;
} | {
    type: "setResolution";
    resolution: [number, number];
} | {
    type: "setCamera";
    camera: Camera;
} | {
    type: "setAutoCameraReset";
    enableReset: boolean;
}, {
    [x: string]: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
        image: MultiscaleSpatialImage;
        dataRanges: import("@itk-viewer/io/types.js").Ranges;
        colorRanges: import("@itk-viewer/io/types.js").Ranges;
        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
        colorMaps: string[];
        opacityPoints: (readonly [number, number])[][];
        normalizedOpacityPoints: (readonly [number, number])[][];
    }, {
        type: "getWorker";
        receiver: AnyActorRef;
    } | {
        type: "builtImage";
        builtImage: BuiltImage;
    } | {
        type: "colorRange";
        range: readonly [number, number];
        component: number;
    } | {
        type: "normalizedColorRange";
        range: readonly [number, number];
        component: number;
    } | {
        type: "opacityPoints";
        points: (readonly [number, number])[];
        component: number;
    } | {
        type: "normalizedOpacityPoints";
        points: (readonly [number, number])[];
        component: number;
    } | {
        type: "colorMap";
        colorMap: string;
        component: number;
    }, {}, "active", string, import("xstate").NonReducibleUnknown, import("xstate").MetaObject, {
        readonly id: "image";
        readonly initial: "active";
        readonly context: ({ input: image }: {
            spawn: {
                <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                    id?: never;
                    systemId?: string;
                    input?: import("xstate").InputFrom<TLogic> | undefined;
                    syncSnapshot?: boolean;
                } | undefined): ActorRefFrom<TLogic>;
            };
            input: MultiscaleSpatialImage;
            self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                image: MultiscaleSpatialImage;
                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                colorMaps: string[];
                opacityPoints: (readonly [number, number])[][];
                normalizedOpacityPoints: (readonly [number, number])[][];
            }, {
                type: "getWorker";
                receiver: AnyActorRef;
            } | {
                type: "builtImage";
                builtImage: BuiltImage;
            } | {
                type: "colorRange";
                range: readonly [number, number];
                component: number;
            } | {
                type: "normalizedColorRange";
                range: readonly [number, number];
                component: number;
            } | {
                type: "opacityPoints";
                points: (readonly [number, number])[];
                component: number;
            } | {
                type: "normalizedOpacityPoints";
                points: (readonly [number, number])[];
                component: number;
            } | {
                type: "colorMap";
                colorMap: string;
                component: number;
            }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                type: "getWorker";
                receiver: AnyActorRef;
            } | {
                type: "builtImage";
                builtImage: BuiltImage;
            } | {
                type: "colorRange";
                range: readonly [number, number];
                component: number;
            } | {
                type: "normalizedColorRange";
                range: readonly [number, number];
                component: number;
            } | {
                type: "opacityPoints";
                points: (readonly [number, number])[];
                component: number;
            } | {
                type: "normalizedOpacityPoints";
                points: (readonly [number, number])[];
                component: number;
            } | {
                type: "colorMap";
                colorMap: string;
                component: number;
            }, import("xstate").AnyEventObject>;
        }) => {
            image: MultiscaleSpatialImage;
            dataRanges: never[];
            colorRanges: never[];
            normalizedColorRanges: never[];
            colorMaps: never[];
            opacityPoints: never[];
            normalizedOpacityPoints: never[];
        };
        readonly states: {
            readonly active: {
                readonly on: {
                    readonly builtImage: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                    };
                    readonly colorRange: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                    };
                    readonly normalizedColorRange: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, "updateColorRanges"];
                    };
                    readonly opacityPoints: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                    };
                    readonly normalizedOpacityPoints: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                    };
                    readonly colorMap: {
                        readonly actions: readonly [import("xstate").ActionFunction<{
                            image: MultiscaleSpatialImage;
                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                            colorMaps: string[];
                            opacityPoints: (readonly [number, number])[][];
                            normalizedOpacityPoints: (readonly [number, number])[][];
                        }, {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, {
                            type: "getWorker";
                            receiver: AnyActorRef;
                        } | {
                            type: "builtImage";
                            builtImage: BuiltImage;
                        } | {
                            type: "colorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "normalizedColorRange";
                            range: readonly [number, number];
                            component: number;
                        } | {
                            type: "opacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "normalizedOpacityPoints";
                            points: (readonly [number, number])[];
                            component: number;
                        } | {
                            type: "colorMap";
                            colorMap: string;
                            component: number;
                        }, undefined, never, never, never, never, never>];
                    };
                };
            };
        };
    }>, {
        type: "getWorker";
        receiver: AnyActorRef;
    } | {
        type: "builtImage";
        builtImage: BuiltImage;
    } | {
        type: "colorRange";
        range: readonly [number, number];
        component: number;
    } | {
        type: "normalizedColorRange";
        range: readonly [number, number];
        component: number;
    } | {
        type: "opacityPoints";
        points: (readonly [number, number])[];
        component: number;
    } | {
        type: "normalizedOpacityPoints";
        points: (readonly [number, number])[];
        component: number;
    } | {
        type: "colorMap";
        colorMap: string;
        component: number;
    }, import("xstate").EventObject> | import("xstate").ActorRef<import("xstate").PromiseSnapshot<BuiltImage, {
        image: MultiscaleSpatialImage;
        scale: number;
    }>, {
        [k: string]: unknown;
        type: string;
    }, import("xstate").EventObject> | undefined;
}, import("xstate").Values<{
    image: {
        src: "image";
        logic: import("xstate").StateMachine<{
            image: MultiscaleSpatialImage;
            dataRanges: import("@itk-viewer/io/types.js").Ranges;
            colorRanges: import("@itk-viewer/io/types.js").Ranges;
            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
            colorMaps: string[];
            opacityPoints: (readonly [number, number])[][];
            normalizedOpacityPoints: (readonly [number, number])[][];
        }, {
            type: "getWorker";
            receiver: AnyActorRef;
        } | {
            type: "builtImage";
            builtImage: BuiltImage;
        } | {
            type: "colorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "normalizedColorRange";
            range: readonly [number, number];
            component: number;
        } | {
            type: "opacityPoints";
            points: (readonly [number, number])[];
            component: number;
        } | {
            type: "normalizedOpacityPoints";
            points: (readonly [number, number])[];
            component: number;
        } | {
            type: "colorMap";
            colorMap: string;
            component: number;
        }, {}, never, import("xstate").Values<{
            updateColorRanges: {
                type: "updateColorRanges";
                params: import("xstate").NonReducibleUnknown;
            };
            updateNormalizedColorRanges: {
                type: "updateNormalizedColorRanges";
                params: import("xstate").NonReducibleUnknown;
            };
            updateOpacityPoints: {
                type: "updateOpacityPoints";
                params: import("xstate").NonReducibleUnknown;
            };
            updateNormalizedOpacityPoints: {
                type: "updateNormalizedOpacityPoints";
                params: import("xstate").NonReducibleUnknown;
            };
            ensureComponentDefaults: {
                type: "ensureComponentDefaults";
                params: import("xstate").NonReducibleUnknown;
            };
        }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
            readonly id: "image";
            readonly initial: "active";
            readonly context: ({ input: image }: {
                spawn: {
                    <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                    <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                        id?: never;
                        systemId?: string;
                        input?: import("xstate").InputFrom<TLogic> | undefined;
                        syncSnapshot?: boolean;
                    } | undefined): ActorRefFrom<TLogic>;
                };
                input: MultiscaleSpatialImage;
                self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                    image: MultiscaleSpatialImage;
                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                    colorMaps: string[];
                    opacityPoints: (readonly [number, number])[][];
                    normalizedOpacityPoints: (readonly [number, number])[][];
                }, {
                    type: "getWorker";
                    receiver: AnyActorRef;
                } | {
                    type: "builtImage";
                    builtImage: BuiltImage;
                } | {
                    type: "colorRange";
                    range: readonly [number, number];
                    component: number;
                } | {
                    type: "normalizedColorRange";
                    range: readonly [number, number];
                    component: number;
                } | {
                    type: "opacityPoints";
                    points: (readonly [number, number])[];
                    component: number;
                } | {
                    type: "normalizedOpacityPoints";
                    points: (readonly [number, number])[];
                    component: number;
                } | {
                    type: "colorMap";
                    colorMap: string;
                    component: number;
                }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                    type: "getWorker";
                    receiver: AnyActorRef;
                } | {
                    type: "builtImage";
                    builtImage: BuiltImage;
                } | {
                    type: "colorRange";
                    range: readonly [number, number];
                    component: number;
                } | {
                    type: "normalizedColorRange";
                    range: readonly [number, number];
                    component: number;
                } | {
                    type: "opacityPoints";
                    points: (readonly [number, number])[];
                    component: number;
                } | {
                    type: "normalizedOpacityPoints";
                    points: (readonly [number, number])[];
                    component: number;
                } | {
                    type: "colorMap";
                    colorMap: string;
                    component: number;
                }, import("xstate").AnyEventObject>;
            }) => {
                image: MultiscaleSpatialImage;
                dataRanges: never[];
                colorRanges: never[];
                normalizedColorRanges: never[];
                colorMaps: never[];
                opacityPoints: never[];
                normalizedOpacityPoints: never[];
            };
            readonly states: {
                readonly active: {
                    readonly on: {
                        readonly builtImage: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                        };
                        readonly colorRange: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                        };
                        readonly normalizedColorRange: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, "updateColorRanges"];
                        };
                        readonly opacityPoints: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                        };
                        readonly normalizedOpacityPoints: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                        };
                        readonly colorMap: {
                            readonly actions: readonly [import("xstate").ActionFunction<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, undefined, never, never, never, never, never>];
                        };
                    };
                };
            };
        }>;
        id: string | undefined;
    };
    imageBuilder: {
        src: "imageBuilder";
        logic: import("xstate").PromiseActorLogic<BuiltImage, {
            image: MultiscaleSpatialImage;
            scale: number;
        }, import("xstate").EventObject>;
        id: string | undefined;
    };
}>, import("xstate").Values<{
    forwardToSpawned: {
        type: "forwardToSpawned";
        params: unknown;
    };
    resetCameraPose: {
        type: "resetCameraPose";
        params: unknown;
    };
}>, never, never, {
    active?: "idle" | "buildingImage" | undefined;
}, string, import("xstate").NonReducibleUnknown, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
    readonly context: () => {
        scale: number;
        spawned: never[];
        autoCameraReset: true;
    };
    readonly id: "view3d";
    readonly initial: "active";
    readonly states: {
        readonly active: {
            readonly on: {
                readonly createChild: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, CreateChild, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>];
                };
                readonly setImage: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>, "resetCameraPose", import("xstate").ActionFunction<Context, {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, import("xstate").Values<{
                        forwardToSpawned: {
                            type: "forwardToSpawned";
                            params: unknown;
                        };
                        resetCameraPose: {
                            type: "resetCameraPose";
                            params: unknown;
                        };
                    }>, never, never, import("xstate").EventObject>];
                    readonly target: ".buildingImage";
                };
                readonly setScale: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "setScale";
                        scale: number;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>];
                    readonly target: ".buildingImage";
                };
                readonly setViewport: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "setViewport";
                        viewport: ViewportActor;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>];
                };
                readonly setResolution: {
                    readonly actions: readonly [({ context: { viewport }, event: { resolution } }: import("xstate").ActionArgs<Context, {
                        type: "setResolution";
                        resolution: [number, number];
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }>) => void];
                };
                readonly setCamera: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "setCamera";
                        camera: Camera;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>, "resetCameraPose", "forwardToSpawned"];
                };
                readonly setAutoCameraReset: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, CreateChild | {
                        type: "setImage";
                        image: MultiscaleSpatialImage;
                    } | {
                        type: "setScale";
                        scale: number;
                    } | {
                        type: "createRenderer";
                        logic: AnyActorLogic;
                    } | {
                        type: "setViewport";
                        viewport: ViewportActor;
                    } | {
                        type: "setResolution";
                        resolution: [number, number];
                    } | {
                        type: "setCamera";
                        camera: Camera;
                    } | {
                        type: "setAutoCameraReset";
                        enableReset: boolean;
                    }, undefined, import("xstate").Values<{
                        image: {
                            src: "image";
                            logic: import("xstate").StateMachine<{
                                image: MultiscaleSpatialImage;
                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                colorMaps: string[];
                                opacityPoints: (readonly [number, number])[][];
                                normalizedOpacityPoints: (readonly [number, number])[][];
                            }, {
                                type: "getWorker";
                                receiver: AnyActorRef;
                            } | {
                                type: "builtImage";
                                builtImage: BuiltImage;
                            } | {
                                type: "colorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "normalizedColorRange";
                                range: readonly [number, number];
                                component: number;
                            } | {
                                type: "opacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "normalizedOpacityPoints";
                                points: (readonly [number, number])[];
                                component: number;
                            } | {
                                type: "colorMap";
                                colorMap: string;
                                component: number;
                            }, {}, never, import("xstate").Values<{
                                updateColorRanges: {
                                    type: "updateColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedColorRanges: {
                                    type: "updateNormalizedColorRanges";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateOpacityPoints: {
                                    type: "updateOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                updateNormalizedOpacityPoints: {
                                    type: "updateNormalizedOpacityPoints";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                                ensureComponentDefaults: {
                                    type: "ensureComponentDefaults";
                                    params: import("xstate").NonReducibleUnknown;
                                };
                            }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                readonly id: "image";
                                readonly initial: "active";
                                readonly context: ({ input: image }: {
                                    spawn: {
                                        <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                        <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                            id?: never;
                                            systemId?: string;
                                            input?: import("xstate").InputFrom<TLogic> | undefined;
                                            syncSnapshot?: boolean;
                                        } | undefined): ActorRefFrom<TLogic>;
                                    };
                                    input: MultiscaleSpatialImage;
                                    self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, import("xstate").AnyEventObject>;
                                }) => {
                                    image: MultiscaleSpatialImage;
                                    dataRanges: never[];
                                    colorRanges: never[];
                                    normalizedColorRanges: never[];
                                    colorMaps: never[];
                                    opacityPoints: never[];
                                    normalizedOpacityPoints: never[];
                                };
                                readonly states: {
                                    readonly active: {
                                        readonly on: {
                                            readonly builtImage: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                            };
                                            readonly colorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                            };
                                            readonly normalizedColorRange: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                            };
                                            readonly opacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                            };
                                            readonly normalizedOpacityPoints: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                            };
                                            readonly colorMap: {
                                                readonly actions: readonly [import("xstate").ActionFunction<{
                                                    image: MultiscaleSpatialImage;
                                                    dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                    colorMaps: string[];
                                                    opacityPoints: (readonly [number, number])[][];
                                                    normalizedOpacityPoints: (readonly [number, number])[][];
                                                }, {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, {
                                                    type: "getWorker";
                                                    receiver: AnyActorRef;
                                                } | {
                                                    type: "builtImage";
                                                    builtImage: BuiltImage;
                                                } | {
                                                    type: "colorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "normalizedColorRange";
                                                    range: readonly [number, number];
                                                    component: number;
                                                } | {
                                                    type: "opacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "normalizedOpacityPoints";
                                                    points: (readonly [number, number])[];
                                                    component: number;
                                                } | {
                                                    type: "colorMap";
                                                    colorMap: string;
                                                    component: number;
                                                }, undefined, never, never, never, never, never>];
                                            };
                                        };
                                    };
                                };
                            }>;
                            id: string | undefined;
                        };
                        imageBuilder: {
                            src: "imageBuilder";
                            logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                image: MultiscaleSpatialImage;
                                scale: number;
                            }, import("xstate").EventObject>;
                            id: string | undefined;
                        };
                    }>, never, never, never, never>];
                };
            };
            readonly initial: "idle";
            readonly states: {
                readonly idle: {};
                readonly buildingImage: {
                    readonly invoke: {
                        readonly input: ({ context }: {
                            context: Context;
                            event: CreateChild | {
                                type: "setImage";
                                image: MultiscaleSpatialImage;
                            } | {
                                type: "setScale";
                                scale: number;
                            } | {
                                type: "createRenderer";
                                logic: AnyActorLogic;
                            } | {
                                type: "setViewport";
                                viewport: ViewportActor;
                            } | {
                                type: "setResolution";
                                resolution: [number, number];
                            } | {
                                type: "setCamera";
                                camera: Camera;
                            } | {
                                type: "setAutoCameraReset";
                                enableReset: boolean;
                            };
                            self: import("xstate").ActorRef<import("xstate").MachineSnapshot<Context, CreateChild | {
                                type: "setImage";
                                image: MultiscaleSpatialImage;
                            } | {
                                type: "setScale";
                                scale: number;
                            } | {
                                type: "createRenderer";
                                logic: AnyActorLogic;
                            } | {
                                type: "setViewport";
                                viewport: ViewportActor;
                            } | {
                                type: "setResolution";
                                resolution: [number, number];
                            } | {
                                type: "setCamera";
                                camera: Camera;
                            } | {
                                type: "setAutoCameraReset";
                                enableReset: boolean;
                            }, Record<string, AnyActorRef>, import("xstate").StateValue, string, unknown, any, any>, CreateChild | {
                                type: "setImage";
                                image: MultiscaleSpatialImage;
                            } | {
                                type: "setScale";
                                scale: number;
                            } | {
                                type: "createRenderer";
                                logic: AnyActorLogic;
                            } | {
                                type: "setViewport";
                                viewport: ViewportActor;
                            } | {
                                type: "setResolution";
                                resolution: [number, number];
                            } | {
                                type: "setCamera";
                                camera: Camera;
                            } | {
                                type: "setAutoCameraReset";
                                enableReset: boolean;
                            }, import("xstate").AnyEventObject>;
                        }) => {
                            image: MultiscaleSpatialImage;
                            scale: number;
                        };
                        readonly src: "imageBuilder";
                        readonly onDone: {
                            readonly actions: readonly [import("xstate").ActionFunction<Context, import("xstate").DoneActorEvent<BuiltImage, string>, CreateChild | {
                                type: "setImage";
                                image: MultiscaleSpatialImage;
                            } | {
                                type: "setScale";
                                scale: number;
                            } | {
                                type: "createRenderer";
                                logic: AnyActorLogic;
                            } | {
                                type: "setViewport";
                                viewport: ViewportActor;
                            } | {
                                type: "setResolution";
                                resolution: [number, number];
                            } | {
                                type: "setCamera";
                                camera: Camera;
                            } | {
                                type: "setAutoCameraReset";
                                enableReset: boolean;
                            }, undefined, import("xstate").Values<{
                                image: {
                                    src: "image";
                                    logic: import("xstate").StateMachine<{
                                        image: MultiscaleSpatialImage;
                                        dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                        colorMaps: string[];
                                        opacityPoints: (readonly [number, number])[][];
                                        normalizedOpacityPoints: (readonly [number, number])[][];
                                    }, {
                                        type: "getWorker";
                                        receiver: AnyActorRef;
                                    } | {
                                        type: "builtImage";
                                        builtImage: BuiltImage;
                                    } | {
                                        type: "colorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "normalizedColorRange";
                                        range: readonly [number, number];
                                        component: number;
                                    } | {
                                        type: "opacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "normalizedOpacityPoints";
                                        points: (readonly [number, number])[];
                                        component: number;
                                    } | {
                                        type: "colorMap";
                                        colorMap: string;
                                        component: number;
                                    }, {}, never, import("xstate").Values<{
                                        updateColorRanges: {
                                            type: "updateColorRanges";
                                            params: import("xstate").NonReducibleUnknown;
                                        };
                                        updateNormalizedColorRanges: {
                                            type: "updateNormalizedColorRanges";
                                            params: import("xstate").NonReducibleUnknown;
                                        };
                                        updateOpacityPoints: {
                                            type: "updateOpacityPoints";
                                            params: import("xstate").NonReducibleUnknown;
                                        };
                                        updateNormalizedOpacityPoints: {
                                            type: "updateNormalizedOpacityPoints";
                                            params: import("xstate").NonReducibleUnknown;
                                        };
                                        ensureComponentDefaults: {
                                            type: "ensureComponentDefaults";
                                            params: import("xstate").NonReducibleUnknown;
                                        };
                                    }>, never, never, "active", string, MultiscaleSpatialImage, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
                                        readonly id: "image";
                                        readonly initial: "active";
                                        readonly context: ({ input: image }: {
                                            spawn: {
                                                <TSrc extends never>(logic: TSrc, ...[options]: never): never;
                                                <TLogic extends AnyActorLogic>(src: TLogic, options?: {
                                                    id?: never;
                                                    systemId?: string;
                                                    input?: import("xstate").InputFrom<TLogic> | undefined;
                                                    syncSnapshot?: boolean;
                                                } | undefined): ActorRefFrom<TLogic>;
                                            };
                                            input: MultiscaleSpatialImage;
                                            self: import("xstate").ActorRef<import("xstate").MachineSnapshot<{
                                                image: MultiscaleSpatialImage;
                                                dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                colorMaps: string[];
                                                opacityPoints: (readonly [number, number])[][];
                                                normalizedOpacityPoints: (readonly [number, number])[][];
                                            }, {
                                                type: "getWorker";
                                                receiver: AnyActorRef;
                                            } | {
                                                type: "builtImage";
                                                builtImage: BuiltImage;
                                            } | {
                                                type: "colorRange";
                                                range: readonly [number, number];
                                                component: number;
                                            } | {
                                                type: "normalizedColorRange";
                                                range: readonly [number, number];
                                                component: number;
                                            } | {
                                                type: "opacityPoints";
                                                points: (readonly [number, number])[];
                                                component: number;
                                            } | {
                                                type: "normalizedOpacityPoints";
                                                points: (readonly [number, number])[];
                                                component: number;
                                            } | {
                                                type: "colorMap";
                                                colorMap: string;
                                                component: number;
                                            }, Record<string, AnyActorRef | undefined>, import("xstate").StateValue, string, unknown, any, any>, {
                                                type: "getWorker";
                                                receiver: AnyActorRef;
                                            } | {
                                                type: "builtImage";
                                                builtImage: BuiltImage;
                                            } | {
                                                type: "colorRange";
                                                range: readonly [number, number];
                                                component: number;
                                            } | {
                                                type: "normalizedColorRange";
                                                range: readonly [number, number];
                                                component: number;
                                            } | {
                                                type: "opacityPoints";
                                                points: (readonly [number, number])[];
                                                component: number;
                                            } | {
                                                type: "normalizedOpacityPoints";
                                                points: (readonly [number, number])[];
                                                component: number;
                                            } | {
                                                type: "colorMap";
                                                colorMap: string;
                                                component: number;
                                            }, import("xstate").AnyEventObject>;
                                        }) => {
                                            image: MultiscaleSpatialImage;
                                            dataRanges: never[];
                                            colorRanges: never[];
                                            normalizedColorRanges: never[];
                                            colorMaps: never[];
                                            opacityPoints: never[];
                                            normalizedOpacityPoints: never[];
                                        };
                                        readonly states: {
                                            readonly active: {
                                                readonly on: {
                                                    readonly builtImage: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges", "updateNormalizedOpacityPoints", "ensureComponentDefaults"];
                                                    };
                                                    readonly colorRange: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, "updateNormalizedColorRanges"];
                                                    };
                                                    readonly normalizedColorRange: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, "updateColorRanges"];
                                                    };
                                                    readonly opacityPoints: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, "updateNormalizedOpacityPoints"];
                                                    };
                                                    readonly normalizedOpacityPoints: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>, "updateOpacityPoints"];
                                                    };
                                                    readonly colorMap: {
                                                        readonly actions: readonly [import("xstate").ActionFunction<{
                                                            image: MultiscaleSpatialImage;
                                                            dataRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            normalizedColorRanges: import("@itk-viewer/io/types.js").Ranges;
                                                            colorMaps: string[];
                                                            opacityPoints: (readonly [number, number])[][];
                                                            normalizedOpacityPoints: (readonly [number, number])[][];
                                                        }, {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, {
                                                            type: "getWorker";
                                                            receiver: AnyActorRef;
                                                        } | {
                                                            type: "builtImage";
                                                            builtImage: BuiltImage;
                                                        } | {
                                                            type: "colorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedColorRange";
                                                            range: readonly [number, number];
                                                            component: number;
                                                        } | {
                                                            type: "opacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "normalizedOpacityPoints";
                                                            points: (readonly [number, number])[];
                                                            component: number;
                                                        } | {
                                                            type: "colorMap";
                                                            colorMap: string;
                                                            component: number;
                                                        }, undefined, never, never, never, never, never>];
                                                    };
                                                };
                                            };
                                        };
                                    }>;
                                    id: string | undefined;
                                };
                                imageBuilder: {
                                    src: "imageBuilder";
                                    logic: import("xstate").PromiseActorLogic<BuiltImage, {
                                        image: MultiscaleSpatialImage;
                                        scale: number;
                                    }, import("xstate").EventObject>;
                                    id: string | undefined;
                                };
                            }>, import("xstate").Values<{
                                forwardToSpawned: {
                                    type: "forwardToSpawned";
                                    params: unknown;
                                };
                                resetCameraPose: {
                                    type: "resetCameraPose";
                                    params: unknown;
                                };
                            }>, never, never, import("xstate").EventObject>];
                        };
                    };
                };
            };
        };
    };
}>;
export type View3dActor = ActorRefFrom<typeof view3d>;
export {};
//# sourceMappingURL=view-3d.d.ts.map