import { ActorRefFrom } from 'xstate';
import MultiscaleSpatialImage from '@itk-viewer/io/MultiscaleSpatialImage.js';
import { CreateChild } from './children.js';
import { ViewportActor } from './viewport.js';
type SetImageEvent = {
    type: 'setImage';
    image: MultiscaleSpatialImage;
    name?: string;
};
type SendImageToViewports = {
    type: 'sendImageToViewports';
    image: MultiscaleSpatialImage;
};
type Context = {
    viewports: ViewportActor[];
    images: Record<string, MultiscaleSpatialImage>;
};
export declare const viewerMachine: import("xstate").StateMachine<Context, CreateChild | SetImageEvent | SendImageToViewports, {}, never, never, never, never, "active", string, import("xstate").NonReducibleUnknown, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
    readonly id: "viewer";
    readonly initial: "active";
    readonly context: {
        readonly viewports: [];
        readonly images: {};
    };
    readonly states: {
        readonly active: {
            readonly on: {
                readonly createChild: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, CreateChild, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>];
                };
                readonly setImage: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, SetImageEvent, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>, import("xstate").ActionFunction<Context, SetImageEvent, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>];
                };
                readonly sendImageToViewports: {
                    readonly actions: readonly [({ context, event: { image } }: import("xstate").ActionArgs<Context, SendImageToViewports, CreateChild | SetImageEvent | SendImageToViewports>) => void];
                };
            };
        };
    };
}>;
export declare const createViewer: () => import("xstate").Actor<import("xstate").StateMachine<Context, CreateChild | SetImageEvent | SendImageToViewports, {}, never, never, never, never, "active", string, import("xstate").NonReducibleUnknown, import("xstate").NonReducibleUnknown, import("xstate").EventObject, import("xstate").MetaObject, {
    readonly id: "viewer";
    readonly initial: "active";
    readonly context: {
        readonly viewports: [];
        readonly images: {};
    };
    readonly states: {
        readonly active: {
            readonly on: {
                readonly createChild: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, CreateChild, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>];
                };
                readonly setImage: {
                    readonly actions: readonly [import("xstate").ActionFunction<Context, SetImageEvent, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>, import("xstate").ActionFunction<Context, SetImageEvent, CreateChild | SetImageEvent | SendImageToViewports, undefined, never, never, never, never, never>];
                };
                readonly sendImageToViewports: {
                    readonly actions: readonly [({ context, event: { image } }: import("xstate").ActionArgs<Context, SendImageToViewports, CreateChild | SetImageEvent | SendImageToViewports>) => void];
                };
            };
        };
    };
}>>;
export type Viewer = ActorRefFrom<typeof viewerMachine>;
export {};
//# sourceMappingURL=viewer.d.ts.map